/***************************************************************
****************************************************************
*				CLASS DE BARRES DE DEFILEMENT                    
****************************************************************
*			    Dveloppe par  ERIC TOULISSE		    	             
*			    	erictoulisse@gmail.com		    	             
****************************************************************
*				Le 21/08/2009 Version 1.0	             
****************************************************************
				HTTP://WWW.WOBYWEB.FR/
****************************************************************/
	
var BarreDefilement = function(NomDiv){
	
	var LeDivPrincipal;
	var Numero;	
	
	/*-----------------------------------------------------------------
				REMPLACE DANS UNE CHAINE
	-----------------------------------------------------------------*/	
	var Remplacer=function remplacer(Phrase,caractere,nouveau){
		while (Phrase.indexOf(caractere)!=-1){
			Phrase=Phrase.replace(caractere,nouveau);
		}
		return Phrase;
	};
	this.remplacer=Remplacer;
	/*-----------------------------------------------------------------
				TROUVER NUMERO DE BARRE INEXISTANT
	-----------------------------------------------------------------*/
		this.TrouverNumeroLibre=function TrouverNumeroLibre(){			
			var PasTrouver=true;
			var Num=0;
			while(PasTrouver){
				Num++;
				if (! document.getElementById("Support_Total_" + Num)){
					if (! document.getElementById("Support_BarreV_" + Num)){
						if (! document.getElementById("Tableau_BarreV_" + Num)){	
							if (! document.getElementById("Support_BarreH_" + Num)){
								if (! document.getElementById("Tableau_BarreH_" + Num)){
									PasTrouver=false;
								}
							}
						}
					}
				}
			}			
			return Num;
		};
		
	/*-----------------------------------------------------------------
				DEFINIR LA HAUTEUR DE LA ZONE
	-----------------------------------------------------------------*/	
		this.DefinirHauteurBarre=function DefinirHauteurBarre(Taille){	
			
			DivSupportTotale.style.height=Taille+"px";
			BarreDefilementV.style.height=DivSupportSecondaire.offsetHeight+"px";
			this.RedessinnerBarreVerticale();
			this.RedessinnerBarreHorizontale();
			this.ActualiserContenuBarre();
		};
	/*-----------------------------------------------------------------
				DEFINIR LA LARGEUR DE LA ZONE
	-----------------------------------------------------------------*/	
		this.DefinirLargeurBarre=function(Taille){	
			
			DivSupportTotale.style.width=Taille+"px";
			BarreDefilementH.style.width=DivSupportSecondaire.offsetWidth+"px";
			this.RedessinnerBarreHorizontale();
			this.RedessinnerBarreVerticale();
			this.ActualiserContenuBarre();
		};
	/*-----------------------------------------------------------------
				ACTUALISATION DU DIV
	-----------------------------------------------------------------*/
		var TimerActualiseur;
		var IntervalActualisation;
		var Actualisation_auto;
		var FonctionActualiserContenuDiv=function ActualiserContenuDiv(){
			
			if(this.TestSiDivAChanger()){
				//GESTIO VERTICALE
					//visibilit
					if(VisiBarreV==3){					
						this.TesterVisibiliteBarreV();
					}
					//recalcul la tialle du curseur
					this.RecalculTailleCurseurV();
					//dcalage auto?			
					if((parseInt(Principal.style.top) ==-(DerniereTailleV-DivSupportSecondaire.offsetHeight)) || DerniereTailleV<DivSupportSecondaire.offsetHeight){					
						Principal.style.top=-(TailleCouranteV-DivSupportSecondaire.offsetHeight)+"px";
					}
					//on remonte ?
					if(parseInt(Principal.offsetHeight)<parseInt(DivSupportSecondaire.offsetHeight)){
						Principal.style.top="0px";
					}
					
					//position du curseur de la barre
					this.RecalculPositionCurseurV();
				//GESTION HORIZONTALE
					//visibilit
					if(VisiBarreH==3){					
						this.TesterVisibiliteBarreH();
					}
					//recalcul la tialle du curseur
					this.RecalculTailleCurseurH();
					//on se remet a gauche ?
					if(parseInt(Principal.offsetWidth)<parseInt(DivSupportSecondaire.offsetWidth)){
						Principal.style.left="0px";
					}
					//position du curseur de la barre
					this.RecalculPositionCurseurH();
				
			}
			if(Actualisation_auto){
				TimerActualiseur=setTimeout(FonctionActualiserContenuDiv,IntervalActualisation);
			}else{
				clearTimeout(TimerActualiseur);
			}
			
		};
		this.ActualiserContenuBarre=FonctionActualiserContenuDiv;
	/*-----------------------------------------------------------------
				RECALCUL LA TAILLE DU JETON VERTICAL
	-----------------------------------------------------------------*/		
		this.RecalculTailleCurseurV=function(){
			var TailleMin=10;
			var TailleMax=DivSupportSecondaire.offsetHeight-IconeBBarreDefilementV.offsetHeight-IconeHBarreDefilementV.offsetHeight;
			if(Principal.offsetHeight<DivSupportSecondaire.offsetHeight){
				var pourcentage=1;
			}else{
				var pourcentage=(DivSupportSecondaire.offsetHeight/Principal.offsetHeight);
			}
			var Taille=pourcentage*TailleMax;
			if(Taille<TailleMin){
				Taille=TailleMin;
			}
			IconeIndiceBarreDefilementV.style.height=Taille+"px";

		};
	/*-----------------------------------------------------------------
				RECALCUL LA TAILLE DU JETON
	-----------------------------------------------------------------*/		
		this.RecalculTailleCurseurH=function(){
			var TailleMin=10;
			var TailleMax=DivSupportSecondaire.offsetWidth-IconeDBarreDefilementH.offsetWidth-IconeGBarreDefilementH.offsetWidth;
			if(Principal.offsetWidth<DivSupportSecondaire.offsetWidth){
				var pourcentage=1;
			}else{
				var pourcentage=(DivSupportSecondaire.offsetWidth/Principal.offsetWidth);
			}
			var Taille=pourcentage*TailleMax;
			if(Taille<TailleMin){
				Taille=TailleMin;
			}
			IconeIndiceBarreDefilementH.style.width=Taille+"px";

		};
		
	/*-----------------------------------------------------------------
				RECALCUL LA POSITION DU JETON VERTICALE
	-----------------------------------------------------------------*/	
		var RecalculerLaPositionCurseurV=function(){
			
			var min=IconeHBarreDefilementV.offsetHeight;
			var max=DivSupportSecondaire.offsetHeight-IconeBBarreDefilementV.offsetHeight-IconeIndiceBarreDefilementV.offsetHeight;
			
			var Postop=parseInt(Remplacer(Principal.style.top,"px",""));
			if(DivSupportSecondaire.offsetHeight==Principal.offsetHeight){
				var pourcentage=0;
			}else{
				if(Principal.style.top==-(Principal.offsetHeight-DivSupportSecondaire.offsetHeight)+"px"){
					var pourcentage=1;
				}else{
					var pourcentage=(Postop/(DivSupportSecondaire.offsetHeight-Principal.offsetHeight));	
				}
			}
			if(pourcentage>1){
				pourcentage=1;
			}
			var position=pourcentage*(max-min)+parseInt(min);			
			
			IconeIndiceBarreDefilementV.style.top=position+"px";
		};	
		this.RecalculPositionCurseurV=RecalculerLaPositionCurseurV;
	/*-----------------------------------------------------------------
				RECALCUL LA POSITION DU JETON HORIZONTALE
	-----------------------------------------------------------------*/	
		var RecalculerLaPositionCurseurH=function(){
			
			var min=IconeGBarreDefilementH.offsetWidth;
			var max=DivSupportSecondaire.offsetWidth-IconeDBarreDefilementH.offsetWidth-IconeIndiceBarreDefilementH.offsetWidth;
			
			var Posleft=parseInt(Remplacer(Principal.style.left,"px",""));
			if(DivSupportSecondaire.offsetWidth==Principal.offsetWidth){
				var pourcentage=0;
			}else{
				if(Principal.style.left==-(Principal.offsetWidth-DivSupportSecondaire.offsetWidth)+"px"){
					var pourcentage=1;
				}else{
					var pourcentage=(Posleft/(DivSupportSecondaire.offsetWidth-Principal.offsetWidth));	
				}
			}
		
			if(pourcentage>1){
				pourcentage=1;
			}
			var position=pourcentage*(max-min)+parseInt(min);			
			
			IconeIndiceBarreDefilementH.style.left=position+"px";
		};	
		this.RecalculPositionCurseurH=RecalculerLaPositionCurseurH;
		
	/*-----------------------------------------------------------------
				ACTUALISATION AUTOMATIQUE TOUTES LES X ms
	-----------------------------------------------------------------*/	
		this.ActualiseAutomatiquement=function ActualiseAutomatiquement(Tps){
			TimerActualiseur=setTimeout(FonctionActualiserContenuDiv,Tps);
			IntervalActualisation=Tps;
			Actualisation_auto=true;
		};
		
	/*-----------------------------------------------------------------
				ACTUALISATION MANUEL
	-----------------------------------------------------------------*/	
		this.ActualiseManuellement=function ActualiseManuellement(){			
			clearTimeout(TimerActualiseur);			
			Actualisation_auto=false;
			
		};
	/*-----------------------------------------------------------------
				TEST SI LE CONTENU DU PRINCIPAL A CHANGER OU PAS
	-----------------------------------------------------------------*/
		var TailleCouranteV=0;
		var DerniereTailleV=0;
		var DerniereHauteurDivSecondaire=0;
		var DerniereLargeurDivSecondaire=0;
		this.TestSiDivAChanger=function TestSiDivAChanger(){
			
			if (TailleCouranteV!=Principal.offsetHeight){
				var res=true;
				DerniereTailleV=TailleCouranteV;			
				TailleCouranteV=Principal.offsetHeight;
				DerniereHauteurDivSecondaire=DivSupportSecondaire.offsetHeight;
				DerniereLargeurDivSecondaire=DivSupportSecondaire.offsetWidth;
			}else{
				if(DivSupportSecondaire.offsetHeight!=DerniereHauteurDivSecondaire){
					var res=true;
					DerniereHauteurDivSecondaire=DivSupportSecondaire.offsetHeight;
					DerniereLargeurDivSecondaire=DivSupportSecondaire.offsetWidth;
				}else{
					if(DivSupportSecondaire.offsetWidth!=DerniereLargeurDivSecondaire){
						var res=true;
						DerniereLargeurDivSecondaire=DivSupportSecondaire.offsetWidth;
					}else{
						var res=false;
					}
				}
			}
			return res;
		};
		
	/*-----------------------------------------------------------------
			CHANGE LA VISIBILITE DES BARRE (1->Visible,2->Cache,3->auto)
	-----------------------------------------------------------------*/	
		var VisiBarreH=3;
		var VisiBarreV=3;
		this.ChangerVisibiliteBarres=function ChangerVisibiliteBarres(visi){
			this.ChangerVisibiliteBarreV(visi);
			this.ChangerVisibiliteBarreH(visi);
		};
	
	/*----------------------------------------------------------------------
	CHANGE LA VISIBILITE DE LA BARRE VERTICALE (1->Visible,2->Cache,3->auto)
	----------------------------------------------------------------------*/	
		this.ChangerVisibiliteBarreV=function ChangerVisibiliteBarreV(visi){
			switch(visi){
				case 1:
					this.MontrerPonctuellementBarreV();
					VisiBarreV=1;
					break;
				case 2:
					this.MasquerPonctuellementBarreV();
					VisiBarreV=2;
					break;
				default:
					this.TesterVisibiliteBarreV();
					VisiBarreV=3;
					break;
			}
		};
	
	/*----------------------------------------------------------------------
	CHANGE LA VISIBILITE DE LA BARRE HORIZONTALE (1->Visible,2->Cache,3->auto)
	----------------------------------------------------------------------*/	
		this.ChangerVisibiliteBarreH=function ChangerVisibiliteBarreH(visi){
			switch(visi){
				case 1:
					this.MontrerPonctuellementBarreH();
					VisiBarreH=1;
					break;
				case 2:
					this.MasquerPonctuellementBarreH();
					VisiBarreH=2;
					break;
				default:
					this.TesterVisibiliteBarreH();
					VisiBarreH=3;
					break;
			}
		};
	/*----------------------------------------------------------------------
			MASQUE PONCTUELLEMENT LA BARRE VERTICALE
	----------------------------------------------------------------------*/
		var BV_Visible=true;
		var BV_Epaisseur_Svg;
		var BH_Epaisseur_Svg;
		var BH_Visible=true;
		this.MasquerPonctuellementBarreV=function(){
			if(BV_Visible){
				BV_Epaisseur_Svg=EpaisseurBarreV;
				this.DefinirEpaisseurBarreVerticale(0);
				BV_Visible=false;
												
				BarreDefilementV.style.display="none";
				BarreDefilementV.style.visibility="hidden";
				IconeHBarreDefilementV.style.display="none";
				IconeHBarreDefilementV.style.visibility="hidden";
				IconeBBarreDefilementV.style.display="none";
				IconeBBarreDefilementV.style.visibility="hidden";
				IconeIndiceBarreDefilementV.style.display="none";
				IconeIndiceBarreDefilementV.style.visibility="hidden";
				
			}
		}
	/*----------------------------------------------------------------------
			MONTRER PONCTUELLEMENT LA BARRE VERTICALE
	----------------------------------------------------------------------*/	
		this.MontrerPonctuellementBarreH=function(){
			if(!BH_Visible){
				BH_Visible=true;
				this.DefinirEpaisseurBarreHorizontale(BH_Epaisseur_Svg);
				BarreDefilementH.style.display="";
				BarreDefilementH.style.visibility="visible";
				IconeGBarreDefilementH.style.display="";
				IconeGBarreDefilementH.style.visibility="visible";
				IconeDBarreDefilementH.style.display="";
				IconeDBarreDefilementH.style.visibility="visible";
				IconeIndiceBarreDefilementH.style.display="";
				IconeIndiceBarreDefilementH.style.visibility="visible";
				this.RedessinnerBarreHorizontale();
			}
		}
	/*----------------------------------------------------------------------
			MASQUE PONCTUELLEMENT LA BARRE VERTICALE
	----------------------------------------------------------------------*/

		this.MasquerPonctuellementBarreH=function(){
			if(BH_Visible){
				BH_Epaisseur_Svg=EpaisseurBarreH;
				this.DefinirEpaisseurBarreHorizontale(0);
				BH_Visible=false;								
				BarreDefilementH.style.display="none";
				BarreDefilementH.style.visibility="hidden";
				IconeDBarreDefilementH.style.display="none";
				IconeDBarreDefilementH.style.visibility="hidden";
				IconeGBarreDefilementH.style.display="none";
				IconeGBarreDefilementH.style.visibility="hidden";
				IconeIndiceBarreDefilementH.style.display="none";
				IconeIndiceBarreDefilementH.style.visibility="hidden";
			}
		}
	/*----------------------------------------------------------------------
			MONTRER PONCTUELLEMENT LA BARRE VERTICALE
	----------------------------------------------------------------------*/	
		this.MontrerPonctuellementBarreV=function(){
			if(!BV_Visible){
				BV_Visible=true;
				this.DefinirEpaisseurBarreVerticale(BV_Epaisseur_Svg);
				BarreDefilementV.style.display="";
				BarreDefilementV.style.visibility="visible";
				IconeHBarreDefilementV.style.display="";
				IconeHBarreDefilementV.style.visibility="visible";
				IconeBBarreDefilementV.style.display="";
				IconeBBarreDefilementV.style.visibility="visible";
				IconeIndiceBarreDefilementV.style.display="";
				IconeIndiceBarreDefilementV.style.visibility="visible";
				this.RedessinnerBarreVerticale();
			}
		}
		
	/*----------------------------------------------------------------------
			TEST VISIBILITE DE  LA BARRE VERTICALE(mode3)
	----------------------------------------------------------------------*/
	this.TesterVisibiliteBarreV=function(){
		if (Principal.offsetHeight>DivSupportSecondaire.offsetHeight){
			this.MontrerPonctuellementBarreV();			
		}else{
			this.MasquerPonctuellementBarreV();
		}
	}
	/*----------------------------------------------------------------------
			TEST VISIBILITE DE  LA BARRE HORIZONTALE(mode3)
	----------------------------------------------------------------------*/
	this.TesterVisibiliteBarreH=function(){
		if (Principal.offsetWidth>DivSupportSecondaire.offsetWidth){
			this.MontrerPonctuellementBarreH();			
		}else{
			this.MasquerPonctuellementBarreH();
		}
	}
	/*-----------------------------------------------------------------
				CHANGE LE PAS DE DEPLACEMENT 
	-----------------------------------------------------------------*/	
		var PasDeplacementV=5;
		var PasDeplacementH=5;
			this.ChangerPasDeplacement=function ChangerPasDeplacement(Pas){
				this.ChangerPasDeplacementV(Pas);
				this.ChangerPasDeplacementH(Pas);
			}
	/*-----------------------------------------------------------------
				CHANGE LE PAS DE DEPLACEMENT VERTICAL 
	-----------------------------------------------------------------*/
			this.ChangerPasDeplacementV=function ChangerPasDeplacementV(Pas){
				PasDeplacementV=Pas;
			}
	/*-----------------------------------------------------------------
				CHANGE LE PAS DE DEPLACEMENT HORIZONTALE
	-----------------------------------------------------------------*/	
			this.ChangerPasDeplacementH=function ChangerPasDeplacementH(Pas){
				PasDeplacementH=Pas;
			}			
	/*-----------------------------------------------------------------
				DEPLACE LA BARRE EN BAS 
	-----------------------------------------------------------------*/	
			this.DeplacerBarreVEnHaut=function DeplacerBarreVEnHaut(){
				Principal.style.top="0px";
				this.RecalculPositionCurseurV();
			}
	/*-----------------------------------------------------------------
				DEPLACE LA BARRE EN BAS 
	-----------------------------------------------------------------*/	
			this.DeplacerBarreVEnBas=function DeplacerBarreVEnBas(){
				if(Principal.offsetHeight>DivSupportSecondaire.offsetHeight){
					Principal.style.top=-(Principal.offsetHeight-DivSupportSecondaire.offsetHeight)+"px";
					this.RecalculPositionCurseurV();
				}
				
			}
	/*-----------------------------------------------------------------
				DEPLACE LA BARRE EN BAS 
	-----------------------------------------------------------------*/	
			this.DeplacerBarreHAGauche=function(){
				Principal.style.left="0px";
				this.RecalculPositionCurseurH();
			}
	/*-----------------------------------------------------------------
				DEPLACE LA BARRE EN BAS 
	-----------------------------------------------------------------*/	
			this.DeplacerBarreHADroite=function(){
				if(Principal.offsetWidth>DivSupportSecondaire.offsetWidth){
					Principal.style.left=-(Principal.offsetWidth-DivSupportSecondaire.offsetWidth)+"px";
					this.RecalculPositionCurseurH();
				}
				
			}
	/*-----------------------------------------------------------------
				RENVOIE LE DIV ICONE HAUT BARRE VERTICALE
	-----------------------------------------------------------------*/	
			this.ObtenirIconeMilieuDefilantV=function ObtenirIconeMilieuDefilantV(){
				return IconeIndiceBarreDefilementV;
			};
	/*-----------------------------------------------------------------
				RENVOIE LE DIV ICONE HAUT BARRE HORIZONTALE
	-----------------------------------------------------------------*/	
			this.ObtenirIconeMilieuDefilantH=function ObtenirIconeMilieuDefilantH(){
				return IconeIndiceBarreDefilementH;
			};
	/*-----------------------------------------------------------------
				RENVOIE LE DIV ICONE HAUT BARRE VERTICALE
	-----------------------------------------------------------------*/	
			this.ObtenirIconeHaut=function ObtenirIconeHaut(){
				return IconeHBarreDefilementV;
			};
	/*-----------------------------------------------------------------
				RENVOIE LE DIV ICONE BAS BARRE VERTICALE
	-----------------------------------------------------------------*/	
			this.ObtenirIconeBas=function ObtenirIconeBas(){
				return IconeBBarreDefilementV;
			};
	/*-----------------------------------------------------------------
				RENVOIE LE DIV ICONE DROIT BARRE HORIZONTALE
	-----------------------------------------------------------------*/	
			this.ObtenirIconeDroite=function(){
				return IconeDBarreDefilementH;
			};
	/*-----------------------------------------------------------------
				RENVOIE LE DIV ICONE GAUCHE BARRE HORIZONTALE
	-----------------------------------------------------------------*/	
			this.ObtenirIconeGauche=function(){
				return IconeGBarreDefilementH;
			};
	/*-----------------------------------------------------------------
				RENVOIE LE SUPPORT TOTALE
	-----------------------------------------------------------------*/	
			this.ObtenirConteneurGlobal=function ObtenirConteneurGlobal(){
				return DivSupportTotale;
			};
	/*-----------------------------------------------------------------
				RENVOIE LA BARRE VERTICALE
	-----------------------------------------------------------------*/	
			this.ObtenirBarreHorizontale=function ObtenirBarreHorizontale(){
				return BarreDefilementH;
			};
	/*-----------------------------------------------------------------
				DEFINIS LA LARGEUR DES DEUX BARRES
	-----------------------------------------------------------------*/	
			var EpaisseurBarreV;
			var EpaisseurBarreH;
			this.DefinirEpaisseurBarres=function DefinirEpaisseurBarres(Epaisseur){
				this.DefinirEpaisseurBarreHorizontale(Epaisseur);	
				this.DefinirEpaisseurBarreVerticale(Epaisseur);
			};
	/*-----------------------------------------------------------------
				DEFINIS LA LARGEUR DE LA BARRE HORIZONTALE
	-----------------------------------------------------------------*/	
			this.DefinirEpaisseurBarreHorizontale=function DefinirEpaisseurBarreHorizontale(Epaisseur){
				if(BH_Visible){
					EpaisseurBarreH=Epaisseur
					var largeur=DivSupportTotale.style.height;				
					largeur=this.remplacer(largeur,"px","");
					largeur=largeur-Epaisseur;
					DivSupportSecondaire.style.height=largeur+"px";
					var Decal=parseInt(BarreDefilementH.style.borderTopWidth);
					if(Epaisseur>Decal){	
						BarreDefilementH.style.height=(Epaisseur-Decal)+"px";
					}else{
						BarreDefilementH.style.height="0px";
					}
					IconeGBarreDefilementH.style.height=BarreDefilementH.style.height;
					IconeDBarreDefilementH.style.height=BarreDefilementH.style.height;
					IconeIndiceBarreDefilementH.style.height=BarreDefilementH.style.height;
					this.RedessinnerBarreVerticale();
				}else{
					BH_Epaisseur_Svg=Epaisseur;
				}
			};
	/*-----------------------------------------------------------------
				DEFINIS LA LARGEUR DE LA BARRE VERTICALE
	-----------------------------------------------------------------*/			
			this.DefinirEpaisseurBarreVerticale=function (Epaisseur){
				if(BV_Visible){				
					EpaisseurBarreV=Epaisseur;
					var largeur=DivSupportTotale.style.width;				
					largeur=this.remplacer(largeur,"px","");
					largeur=largeur-Epaisseur;
					DivSupportSecondaire.style.width=largeur+"px";
				
					var Decal=parseInt(BarreDefilementV.style.borderLeftWidth);
					if(Epaisseur>Decal){					
						BarreDefilementV.style.width=(Epaisseur-Decal)+"px";
					}else{
						BarreDefilementV.style.width="0px";
					}
					IconeBBarreDefilementV.style.width=BarreDefilementV.style.width;
					IconeHBarreDefilementV.style.width=BarreDefilementV.style.width;
					IconeIndiceBarreDefilementV.style.width=BarreDefilementV.style.width;
					
					this.RedessinnerBarreHorizontale();
				}else{
					BV_Epaisseur_Svg=Epaisseur;
				}
			};
	/*-----------------------------------------------------------------
				RETOURNE LA BARRE DE DEFILEMENT VERTICALE
	-----------------------------------------------------------------*/	
		this.ObtenirBarreVerticale=function ObtenirBarreVerticale(){
			return BarreDefilementV;
		};	
	/*-----------------------------------------------------------------
				DEPLACE LE DIV PRINCIPAL EN VERTICAL DE X px
	-----------------------------------------------------------------*/		
		var deplacerprincipalvenpx=function DeplacerPrincipalVenPx(NbPx){
			if(parseInt(Principal.offsetHeight)>=parseInt(DivSupportSecondaire.offsetHeight)){
			
				if(parseInt(Principal.style.top) + NbPx>0)  {					
					Principal.style.top="0px";
					clearTimeout(Timer);																
				}else{
					if(parseInt(Principal.style.top) + NbPx<-(Principal.offsetHeight-DivSupportSecondaire.offsetHeight)) {					
						Principal.style.top=-(Principal.offsetHeight-DivSupportSecondaire.offsetHeight)+"px";
						clearTimeout(Timer);
																		
					}else{
						Principal.style.top = (parseInt(Principal.style.top) + NbPx) + "px";														
						RecalculerLaPositionCurseurV();																																	
					}
				}
			}
		};
		this.DeplacerPrincipalVenPx=deplacerprincipalvenpx;
	/*-----------------------------------------------------------------
				DEPLACE LE DIV PRINCIPAL EN HORIZONTALE DE X px
	-----------------------------------------------------------------*/		
		var deplacerprincipalhenpx=function(NbPx){
			if(parseInt(Principal.offsetWidth)>=parseInt(DivSupportSecondaire.offsetWidth)){
			
				if(parseInt(Principal.style.left) + NbPx>0)  {					
					Principal.style.left="0px";
					clearTimeout(Timer);																
				}else{
					if(parseInt(Principal.style.left) + NbPx<-(Principal.offsetWidth-DivSupportSecondaire.offsetWidth)) {					
						Principal.style.left=-(Principal.offsetWidth-DivSupportSecondaire.offsetWidth)+"px";
						clearTimeout(Timer);
																		
					}else{
						Principal.style.left = (parseInt(Principal.style.left) + NbPx) + "px";														
						RecalculerLaPositionCurseurH();																																	
					}
				}
			}
		};
		this.DeplacerPrincipalHenPx=deplacerprincipalhenpx;
	/*-----------------------------------------------------------------
				DEPLACE LE CURSEUR VERTICAL DE X px
	-----------------------------------------------------------------*/
		var deplacerbarrevenpx=function DeplacerBarreVenPx(NbPx){			
			var min=IconeHBarreDefilementV.offsetHeight;
			var max=DivSupportSecondaire.offsetHeight-IconeBBarreDefilementV.offsetHeight-IconeIndiceBarreDefilementV.offsetHeight;
			
			var pos=parseInt(IconeIndiceBarreDefilementV.style.top);
			if(pos+NbPx>max){				
				NbPx=max-pos;
			}
			if(pos+NbPx<min){				
				NbPx=pos-min;
			}
			
			IconeIndiceBarreDefilementV.style.top=pos+NbPx+"px"
			var TailleTotale=Principal.offsetHeight-DivSupportSecondaire.offsetHeight;
			
			deplacerprincipalvenpx(-1* parseInt(TailleTotale*(NbPx/(max-min))));
		};
		this.DeplacerBarreVenPx=deplacerbarrevenpx;
	/*-----------------------------------------------------------------
				DEPLACE LE CURSEUR HORIZONTALE DE X px
	-----------------------------------------------------------------*/
		var deplacerbarrehenpx=function DeplacerBarreHenPx(NbPx){			
			var min=IconeGBarreDefilementH.offsetWidth;
			var max=DivSupportSecondaire.offsetWidth-IconeDBarreDefilementH.offsetWidth-IconeIndiceBarreDefilementH.offsetWidth;
			
			var left=parseInt(IconeIndiceBarreDefilementH.style.left);
			if(left+NbPx>max){				
				NbPx=max-left;
			}
			if(left+NbPx<min){				
				NbPx=left-min;
			}
			
			IconeIndiceBarreDefilementH.style.left=left+NbPx+"px";
			
			var TailleTotale=Principal.offsetWidth-DivSupportSecondaire.offsetWidth;
			
			deplacerprincipalhenpx(-1* parseInt(TailleTotale*(NbPx/(max-min))));
		};
		this.DeplacerBarreHenPx=deplacerbarrehenpx;
	/*-----------------------------------------------------------------
				STOP LE TIMER
	-----------------------------------------------------------------*/		
		var Timer;
		var ArreterTimer=function(){
			clearTimeout(Timer);
		};
	/*-----------------------------------------------------------------
				DESCEND LA BARRE
	-----------------------------------------------------------------*/	
		var DescendreBarreV=function(){
			deplacerprincipalvenpx(-1*PasDeplacementV);
			Timer = setTimeout(DescendreBarreV, 30);	
		};
	/*-----------------------------------------------------------------
				MONTE LA BARRE
	-----------------------------------------------------------------*/	
		var MonterBarreV=function(){
			deplacerprincipalvenpx(1*PasDeplacementV);
			Timer = setTimeout(MonterBarreV, 30);	
		};
	/*-----------------------------------------------------------------
				DROITE LA BARRE
	-----------------------------------------------------------------*/	
		var DroiteBarreH=function(){
			deplacerprincipalhenpx(-1*PasDeplacementH);
			Timer = setTimeout(DroiteBarreH, 30);	
		};
	/*-----------------------------------------------------------------
				GAUCHE LA BARRE
	-----------------------------------------------------------------*/	
		var GaucheBarreH=function(){
			deplacerprincipalhenpx(1*PasDeplacementH);
			Timer = setTimeout(GaucheBarreH, 30);	
		};			
	/*-----------------------------------------------------------------
				GESTION DE LA ROULETTE
	-----------------------------------------------------------------*/
		var RouletteSouris=function RouletteSouris(){
			
			var delta = 0;
				if (!event) /* For IE. */
						event = window.event;
				if (event.wheelDelta) { /* IE/Opera. */
						delta = event.wheelDelta/120;               
						if (window.opera)
								delta = -delta;
				} else if (event.detail) {
						delta = -event.detail/3;
				}
		   			
				if (delta){
					if(delta<0){
						deplacerprincipalvenpx(-1*PasDeplacementV);
					}else{
						deplacerprincipalvenpx(1*PasDeplacementV);
					}
				}
				if (event.preventDefault)
						event.preventDefault();
			event.returnValue = false;
			
		};
	/*-----------------------------------------------------------------
				ACTIVATION DEPLACEMENT MOUSEOVER
	-----------------------------------------------------------------*/
		var DplActiverOver;
		this.ActiverDeplacementMouseOver=function(activer){
			if(DplActiverOver!==activer){
				
				if(activer){
					AjouterEvenement(IconeDBarreDefilementH,"mouseover",DroiteBarreH);
					AjouterEvenement(IconeGBarreDefilementH,"mouseover",GaucheBarreH);
					AjouterEvenement(IconeBBarreDefilementV,"mouseover",DescendreBarreV);
					AjouterEvenement(IconeHBarreDefilementV,"mouseover",MonterBarreV);
				}else{
					SupprimerEvenement(IconeDBarreDefilementH,"mouseover",DroiteBarreH);
					SupprimerEvenement(IconeGBarreDefilementH,"mouseover",GaucheBarreH);
					SupprimerEvenement(IconeBBarreDefilementV,"mouseover",DescendreBarreV);
					SupprimerEvenement(IconeHBarreDefilementV,"mouseover",MonterBarreV);
				}
				DplActiverOver=activer;
			}
			
		}
	/*-----------------------------------------------------------------
				ACTIVATION DEPLACEMENT MOUSECLICK
	-----------------------------------------------------------------*/
		var DplActiverClick;
		this.ActiverDeplacementMouseClick=function(activer){
			if(DplActiverClick!==activer){
				
				if(activer){
					AjouterEvenement(IconeDBarreDefilementH,"mousedown",DroiteBarreH);
					AjouterEvenement(IconeGBarreDefilementH,"mousedown",GaucheBarreH);
					AjouterEvenement(IconeDBarreDefilementH,"mouseup",ArreterTimer);
					AjouterEvenement(IconeGBarreDefilementH,"mouseup",ArreterTimer);
					
					AjouterEvenement(IconeHBarreDefilementV,"mouseup",ArreterTimer);
					AjouterEvenement(IconeBBarreDefilementV,"mouseup",ArreterTimer);
					AjouterEvenement(IconeBBarreDefilementV,"mousedown",DescendreBarreV);
					AjouterEvenement(IconeHBarreDefilementV,"mousedown",MonterBarreV);
				}else{
					SupprimerEvenement(IconeDBarreDefilementH,"mousedown",DroiteBarreH);
					SupprimerEvenement(IconeGBarreDefilementH,"mousedown",GaucheBarreH);
					SupprimerEvenement(IconeDBarreDefilementH,"mouseup",ArreterTimer);
					SupprimerEvenement(IconeGBarreDefilementH,"mouseup",ArreterTimer);
					
					
					SupprimerEvenement(IconeHBarreDefilementV,"mouseup",ArreterTimer);
					SupprimerEvenement(IconeBBarreDefilementV,"mouseup",ArreterTimer);
					SupprimerEvenement(IconeBBarreDefilementV,"mousedown",DescendreBarreV);
					SupprimerEvenement(IconeHBarreDefilementV,"mousedown",MonterBarreV);
				}
				DplActiverClick=activer;
			}
			
		}
	/*-----------------------------------------------------------------
				ARRETE LE DEPLACEMENT VERTICALE DU CURSEUR
	-----------------------------------------------------------------*/	
		var DoisBougerCurseurV=false;
		var DoisBougerVPosY;
		var ArreterDeplacementCurseurVerticale=function(){		
			DoisBougerCurseurV=false;
		};
	/*-----------------------------------------------------------------
				COMMENCE LE DEPLACEMENT VERTICALE DU CURSEUR
	-----------------------------------------------------------------*/		
		var CommencerDeplacementCurseurVerticale=function(e){		
			var ev = e || window.event;												
			DoisBougerVPosY = ev.clientY;
			DoisBougerCurseurV=true;
		};
	/*-----------------------------------------------------------------
				DEPLACEMENT VERTICALE DU CURSEUR
	-----------------------------------------------------------------*/	
		var DeplacementCurseurVerticale=function(e){		
			if(DoisBougerCurseurV){							
				var ev = e || window.event;										
				var diffy=ev.clientY-DoisBougerVPosY;
				DoisBougerVPosY = ev.clientY;
				if(diffy!=0){
					deplacerbarrevenpx(diffy);
				}
					
			}
		};
	/*-----------------------------------------------------------------
				ARRETE LE DEPLACEMENT HORIZONTALE DU CURSEUR
	-----------------------------------------------------------------*/	
		var DoisBougerCurseurH=false;
		var DoisBougerHPosX;
		var ArreterDeplacementCurseurHorizontale=function(){		
			DoisBougerCurseurH=false;
		};
	/*-----------------------------------------------------------------
				COMMENCE LE DEPLACEMENT HORIZONTALE DU CURSEUR
	-----------------------------------------------------------------*/		
		var CommencerDeplacementCurseurHorizontale=function(e){		
			var ev = e || window.event;											
			DoisBougerHPosX = ev.clientX;
			DoisBougerCurseurH=true;
		};
	/*-----------------------------------------------------------------
				DEPLACEMENT HORIZONTALE DU CURSEUR
	-----------------------------------------------------------------*/	
		var DeplacementCurseurHorizontale=function(e){		
			if(DoisBougerCurseurH){							
				var ev = e || window.event;						
				var diffx=ev.clientX-DoisBougerHPosX;
				DoisBougerHPosX = ev.clientX;
				if(diffx!=0){
					deplacerbarrehenpx(diffx);
				}
					
			}
		};
	/*----------------------------------------------------------------
				AJOUTE UN EVENEMENT AU CLAQUE
	------------------------------------------------------------------*/
		var AjouterEvenement=function(Div,Evenement,fonction){
			if(Evenement.substr(0,2)=="on"){
				var EventIe=Evenement;
				var EventAutre=Evenement.substr(2);
			}else{
				var EventIe="on"+Evenement;
				var EventAutre=Evenement;
			}
			if(typeof Div.attachEvent != 'undefined'){ //.. win/ie 
				Div.attachEvent(EventIe,fonction);
			}else{			
				Div.addEventListener(EventAutre, fonction, false);
			}
		};
	/*----------------------------------------------------------------
				SUPPRIME UN EVENEMENT AU CLAQUE
	------------------------------------------------------------------*/
		var SupprimerEvenement=function(Div,Evenement,fonction){
			if(Evenement.substr(0,2)=="on"){
				var EventIe=Evenement;
				var EventAutre=Evenement.substr(2);
			}else{
				var EventIe="on"+Evenement;
				var EventAutre=Evenement;
			}
			if(typeof Div.detachEvent != 'undefined'){ //.. win/ie 
				Div.detachEvent(EventIe,fonction);
			}else{			
				Div.removeEventListener(EventAutre, fonction, false);
			}
		};
	/*----------------------------------------------------------------
				MET LA COULEUR DE FOND SECONDAIRE SUR UN OBJET
	------------------------------------------------------------------*/
		var CouleurFondBase="#999999";
		var CouleurFondSecondaire="#777777";
		var MettreObjetCouleurFondBase=function(Obj){
			Obj.style.backgroundColor=CouleurFondBase;
		}
		var MettreObjetCouleurFondSecondaire=function(Obj){
			Obj.style.backgroundColor=CouleurFondSecondaire;
		}
		this.DefinirCouleurFondBase=function(couleur){
			CouleurFondBase=couleur;
			MettreObjetCouleurFondBase(IconeBBarreDefilementV);
			MettreObjetCouleurFondBase(IconeHBarreDefilementV);
			MettreObjetCouleurFondBase(IconeIndiceBarreDefilementV);
			MettreObjetCouleurFondBase(IconeGBarreDefilementH);
			MettreObjetCouleurFondBase(IconeDBarreDefilementH);
			MettreObjetCouleurFondBase(IconeIndiceBarreDefilementH);
		}
		this.DefinirCouleurFondSecondaire=function(couleur){
			CouleurFondSecondaire=couleur;
		}
	/*----------------------------------------------------------------
				ACTIVE DESACTIVE CHANGEMENT DE FOND PASSAGE SOURIS
	------------------------------------------------------------------*/	
		var FondChangementSourisActif;
		this.ActiverChangementFondPassageSouris=function(activer){
			if(FondChangementSourisActif!==activer){
				FondChangementSourisActif=activer;
				
				if(activer){	
					AjouterEvenement(IconeDBarreDefilementH,"mouseout",ChangerCouleurIconeDBarreDefilementHBase);
					AjouterEvenement(IconeDBarreDefilementH,"mouseover",ChangerCouleurIconeDBarreDefilementHSecondaire);
					AjouterEvenement(IconeGBarreDefilementH,"mouseout",ChangerCouleurIconeGBarreDefilementHBase);
					AjouterEvenement(IconeGBarreDefilementH,"mouseover",ChangerCouleurIconeGBarreDefilementHSecondaire);
					AjouterEvenement(IconeIndiceBarreDefilementH,"mouseout",ChangerCouleurIconeIndiceBarreDefilementHBase);
					AjouterEvenement(IconeIndiceBarreDefilementH,"mouseover",ChangerCouleurIconeIndiceBarreDefilementHSecondaire);
					
					AjouterEvenement(IconeBBarreDefilementV,"mouseout",ChangerCouleurIconeBBarreDefilementVBase);
					AjouterEvenement(IconeBBarreDefilementV,"mouseover",ChangerCouleurIconeBBarreDefilementVSecondaire);
					AjouterEvenement(IconeHBarreDefilementV,"mouseout",ChangerCouleurIconeHBarreDefilementVBase);
					AjouterEvenement(IconeHBarreDefilementV,"mouseover",ChangerCouleurIconeHBarreDefilementVSecondaire);
					AjouterEvenement(IconeIndiceBarreDefilementV,"mouseout",ChangerCouleurIconeIndiceBarreDefilementVBase);
					AjouterEvenement(IconeIndiceBarreDefilementV,"mouseover",ChangerCouleurIconeIndiceBarreDefilementVSecondaire);
				}else{
					SupprimerEvenement(IconeDBarreDefilementH,"mouseout",ChangerCouleurIconeDBarreDefilementHBase);
					SupprimerEvenement(IconeDBarreDefilementH,"mouseover",ChangerCouleurIconeDBarreDefilementHSecondaire);
					SupprimerEvenement(IconeGBarreDefilementH,"mouseout",ChangerCouleurIconeGBarreDefilementHBase);
					SupprimerEvenement(IconeGBarreDefilementH,"mouseover",ChangerCouleurIconeGBarreDefilementHSecondaire);
					SupprimerEvenement(IconeIndiceBarreDefilementH,"mouseout",ChangerCouleurIconeIndiceBarreDefilementHBase);
					SupprimerEvenement(IconeIndiceBarreDefilementH,"mouseover",ChangerCouleurIconeIndiceBarreDefilementHSecondaire);
					
					SupprimerEvenement(IconeBBarreDefilementV,"mouseout",ChangerCouleurIconeBBarreDefilementVBase);
					SupprimerEvenement(IconeBBarreDefilementV,"mouseover",ChangerCouleurIconeBBarreDefilementVSecondaire);
					SupprimerEvenement(IconeHBarreDefilementV,"mouseout",ChangerCouleurIconeHBarreDefilementVBase);
					SupprimerEvenement(IconeHBarreDefilementV,"mouseover",ChangerCouleurIconeHBarreDefilementVSecondaire);
					SupprimerEvenement(IconeIndiceBarreDefilementV,"mouseout",ChangerCouleurIconeIndiceBarreDefilementVBase);
					SupprimerEvenement(IconeIndiceBarreDefilementV,"mouseover",ChangerCouleurIconeIndiceBarreDefilementVSecondaire);
				}
			}
		}
	/*-----------------------------------------------------------------
				RETOURNE LA POSITION D'UN ELEMENT 
	-----------------------------------------------------------------*/
		var findposleft=function FindPosLeft(obj) {
			var curleft= 0;
			if (obj.offsetParent) {
				do {
					curleft += obj.offsetLeft;
				} while (obj = obj.offsetParent);
				return curleft;
			}
		}
		var findpostop=function FindPosTop(obj) {
			var curtop = 0;
			if (obj.offsetParent) {
				do {
					curtop += obj.offsetTop;
				} while (obj = obj.offsetParent);
				return curtop;
			}
		}
		this.FindPosTop=findpostop;
		this.FindPosLeft=findposleft;
	/*-----------------------------------------------------------------
				REDESSINE LA BARRE VERTICALE
	-----------------------------------------------------------------*/
		this.RedessinnerBarreVerticale=function(){
			DivSupportSecondaire.style.height=(DivSupportTotale.offsetHeight-EpaisseurBarreH-2)+"px";
			BarreDefilementV.style.height=DivSupportSecondaire.offsetHeight+"px";		
			this.RecalculTailleCurseurV();			
			RecalculerLaPositionCurseurV();			
		};
	/*-----------------------------------------------------------------
				REDESSINE LA BARRE HORIZONTALE
	-----------------------------------------------------------------*/
		
		this.RedessinnerBarreHorizontale=function(){
			DivSupportSecondaire.style.width=(DivSupportTotale.offsetWidth-EpaisseurBarreV-2)+"px";

			BarreDefilementH.style.width=DivSupportSecondaire.offsetWidth+"px";
			
			this.RecalculTailleCurseurH();
			RecalculerLaPositionCurseurH();
		};
	/*-------------------------------------------------
		GENERATION DU CONTEXTE GLOBALE
	-------------------------------------------------*/
		LeDivPrincipal=NomDiv;	
		Numero=this.TrouverNumeroLibre();
	
	//ON CREE LE SUPPORT TOTALE		
		var Principal=document.getElementById(LeDivPrincipal).cloneNode(true);
		var DivSupportTotale=document.getElementById(LeDivPrincipal);		
		DivSupportTotale.id="Support_Total_" + Numero;
		DivSupportTotale.innerHTML="";			
		for(var i=0;i<DivSupportTotale.attributes.length;i++){
			if(DivSupportTotale.attributes[i].name!="id"){
				
				DivSupportTotale.removeAttribute(DivSupportTotale.attributes[i].name);
			}
		}	
		DivSupportTotale.style.border=Principal.style.border;
		DivSupportTotale.style.textAlign="left";
		AjouterEvenement(DivSupportTotale,"mousewheel",RouletteSouris);
		if (DivSupportTotale.addEventListener)
		DivSupportTotale.addEventListener('DOMMouseScroll', RouletteSouris, false);
		

		Principal.style.borderWidth="0px";
		Principal.style.border="";


		Principal.style.position="absolute";
		Principal.style.top="0px";
		Principal.style.left="0px";
		Principal.style.overflow="visible";
		DivSupportTotale.style.width=Principal.style.width;
		DivSupportTotale.style.height=Principal.style.height;
		DivSupportTotale.style.overflow="hidden";
		Principal.style.overflow="visible";
		Principal.style.height="";
		Principal.style.width="";
		DivSupportTotale.style.position="relative";
		
		var DivSupportSecondaire=document.createElement("DIV");
		DivSupportSecondaire.style.width=DivSupportTotale.style.width;
		DivSupportSecondaire.style.height=DivSupportTotale.style.height;
		DivSupportSecondaire.style.textAlign="left";
		DivSupportSecondaire.style.overflow="hidden";
		DivSupportSecondaire.style.position="relative";
		//DivSupportSecondaire.style.border="1px solid black";
		
		DivSupportSecondaire.appendChild(Principal);
		DivSupportTotale.appendChild(DivSupportSecondaire);
	
	/*-------------------------------------------------
		GENERATION DE LA BARRE VERTICALE
	-------------------------------------------------*/
	//on crer la barre vertical de dfilement par dfault	
		var BarreDefilementV=document.createElement("Div");
		BarreDefilementV.id="Support_BarreV_" + Numero;
		BarreDefilementV.style.position="absolute";
		BarreDefilementV.style.right="0px";
		BarreDefilementV.style.top="0px";		
		BarreDefilementV.style.borderLeft="1px solid #CCCCCC";
		BarreDefilementV.style.backgroundColor="#CCCCCC";
		BarreDefilementV.innerHTML="&nbsp;";		
		DivSupportTotale.appendChild(BarreDefilementV);
	
		//icone bas
			var IconeBBarreDefilementV=document.createElement("Div");
				IconeBBarreDefilementV.id="Support_IB_BarreV_" + Numero;
				IconeBBarreDefilementV.style.position="absolute";				
				IconeBBarreDefilementV.style.bottom="0px";
				IconeBBarreDefilementV.style.right="0px";
				IconeBBarreDefilementV.innerHTML="&nbsp;";
				IconeBBarreDefilementV.style.backgroundColor="#999999";				
				var ChangerCouleurIconeBBarreDefilementVBase=function(){ MettreObjetCouleurFondBase(IconeBBarreDefilementV)};
				var ChangerCouleurIconeBBarreDefilementVSecondaire=function(){ MettreObjetCouleurFondSecondaire(IconeBBarreDefilementV)};
				IconeBBarreDefilementV.style.border="1px solid black";
				IconeBBarreDefilementV.style.width=BarreDefilementV.style.width;
				BarreDefilementV.appendChild(IconeBBarreDefilementV);
				AjouterEvenement(IconeBBarreDefilementV,"mouseout",ArreterTimer);
				
		//icone haut
			var IconeHBarreDefilementV=document.createElement("Div");
				IconeHBarreDefilementV.id="Support_IH_BarreV_" + Numero;
				IconeHBarreDefilementV.style.position="absolute";
				IconeHBarreDefilementV.style.top="0px";
				IconeHBarreDefilementV.style.right="0px";
				IconeHBarreDefilementV.innerHTML="&nbsp;";
				IconeHBarreDefilementV.style.backgroundColor="#999999";
				var ChangerCouleurIconeHBarreDefilementVBase=function(){ MettreObjetCouleurFondBase(IconeHBarreDefilementV)};
				var ChangerCouleurIconeHBarreDefilementVSecondaire=function(){ MettreObjetCouleurFondSecondaire(IconeHBarreDefilementV)};				
				IconeHBarreDefilementV.style.border="1px solid black";
				IconeHBarreDefilementV.style.width=BarreDefilementV.style.width;				
				AjouterEvenement(IconeHBarreDefilementV,"mouseout",ArreterTimer);
				BarreDefilementV.appendChild(IconeHBarreDefilementV);
		//curseur dfilant	
			var IconeIndiceBarreDefilementV=document.createElement("Div");
				IconeIndiceBarreDefilementV.id="Support_Indice_BarreV_" + Numero;
				IconeIndiceBarreDefilementV.style.position="absolute";
				IconeIndiceBarreDefilementV.style.top=IconeHBarreDefilementV.offsetHeight+"px";
				IconeIndiceBarreDefilementV.style.right="0px";
				IconeIndiceBarreDefilementV.innerHTML="&nbsp;";
				IconeIndiceBarreDefilementV.style.backgroundColor="#AAAAAA";
				IconeIndiceBarreDefilementV.style.border="1px solid black";
				
				var ChangerCouleurIconeIndiceBarreDefilementVBase=function(){ MettreObjetCouleurFondBase(IconeIndiceBarreDefilementV)};
				var ChangerCouleurIconeIndiceBarreDefilementVSecondaire=function(){ MettreObjetCouleurFondSecondaire(IconeIndiceBarreDefilementV)};
		
				
				AjouterEvenement(IconeIndiceBarreDefilementV,"mousemove",DeplacementCurseurVerticale);
				AjouterEvenement(IconeIndiceBarreDefilementV,"mousedown",CommencerDeplacementCurseurVerticale);	
					
				AjouterEvenement(IconeIndiceBarreDefilementV,"mouseup",ArreterDeplacementCurseurVerticale);				
				AjouterEvenement(IconeIndiceBarreDefilementV,"mouseout",ArreterDeplacementCurseurVerticale);				

				
				IconeIndiceBarreDefilementV.style.width=BarreDefilementV.style.width;
				//DivSupportTotale.appendChild(IconeIndiceBarreDefilementV);
				BarreDefilementV.appendChild(IconeIndiceBarreDefilementV);

	/*-------------------------------------------------
		GENERATION DE LA BARRE HORIZONTALE
	-------------------------------------------------*/	
		//on crer la barre vertical de dfilement par dfault	
			var BarreDefilementH=document.createElement("Div");
			BarreDefilementH.id="Support_BarreH_" + Numero;
			BarreDefilementH.style.position="absolute";
			BarreDefilementH.style.left="0px";
			BarreDefilementH.style.bottom="0px";		
					
			BarreDefilementH.style.borderTop="1px solid #CCCCCC";
			BarreDefilementH.style.backgroundColor="#CCCCCC";
			BarreDefilementH.innerHTML="&nbsp;";			
			DivSupportTotale.appendChild(BarreDefilementH);
		//icone droite
			var IconeDBarreDefilementH=document.createElement("Div");
			IconeDBarreDefilementH.id="Support_ID_BarreH_" + Numero;
			IconeDBarreDefilementH.style.position="absolute";				
			IconeDBarreDefilementH.style.width="15px";
			IconeDBarreDefilementH.style.bottom="0px";
			IconeDBarreDefilementH.style.right="0px";
			IconeDBarreDefilementH.innerHTML="&nbsp;";
			IconeDBarreDefilementH.style.backgroundColor="#999999";				
			var ChangerCouleurIconeDBarreDefilementHBase=function(){ MettreObjetCouleurFondBase(IconeDBarreDefilementH)};
			var ChangerCouleurIconeDBarreDefilementHSecondaire=function(){ MettreObjetCouleurFondSecondaire(IconeDBarreDefilementH)};
			IconeDBarreDefilementH.style.border="1px solid black";
			IconeDBarreDefilementH.style.height=BarreDefilementH.style.height;
			BarreDefilementH.appendChild(IconeDBarreDefilementH);		
			AjouterEvenement(IconeDBarreDefilementH,"mouseout",ArreterTimer);
		//icone gauche
			var IconeGBarreDefilementH=document.createElement("Div");
			IconeGBarreDefilementH.id="Support_IG_BarreH_" + Numero;
			IconeGBarreDefilementH.style.position="absolute";
			IconeGBarreDefilementH.style.width="15px";			
			IconeGBarreDefilementH.style.bottom="0px";
			IconeGBarreDefilementH.style.left="0px";
			IconeGBarreDefilementH.innerHTML="&nbsp;";
			IconeGBarreDefilementH.style.backgroundColor="#999999";				
			var ChangerCouleurIconeGBarreDefilementHBase=function(){ MettreObjetCouleurFondBase(IconeGBarreDefilementH)};
			var ChangerCouleurIconeGBarreDefilementHSecondaire=function(){ MettreObjetCouleurFondSecondaire(IconeGBarreDefilementH)};
			IconeGBarreDefilementH.style.border="1px solid black";
			IconeGBarreDefilementH.style.height=BarreDefilementH.style.height;
			BarreDefilementH.appendChild(IconeGBarreDefilementH);		
			AjouterEvenement(IconeGBarreDefilementH,"mouseout",ArreterTimer);
		//curseur dfilant	
			var IconeIndiceBarreDefilementH=document.createElement("Div");
			IconeIndiceBarreDefilementH.id="Support_Indice_BarreV_" + Numero;
			IconeIndiceBarreDefilementH.style.position="absolute";
			IconeIndiceBarreDefilementH.style.left=IconeGBarreDefilementH.offsetHeight+"px";
			IconeIndiceBarreDefilementH.style.bottom="0px";
			IconeIndiceBarreDefilementH.innerHTML="&nbsp;";
			IconeIndiceBarreDefilementH.style.backgroundColor="#AAAAAA";
			IconeIndiceBarreDefilementH.style.border="1px solid black";
				
			var ChangerCouleurIconeIndiceBarreDefilementHBase=function(){ MettreObjetCouleurFondBase(IconeIndiceBarreDefilementH)};
			var ChangerCouleurIconeIndiceBarreDefilementHSecondaire=function(){ MettreObjetCouleurFondSecondaire(IconeIndiceBarreDefilementH)};
		

			AjouterEvenement(IconeIndiceBarreDefilementH,"mousemove",DeplacementCurseurHorizontale);
			AjouterEvenement(IconeIndiceBarreDefilementH,"mousedown",CommencerDeplacementCurseurHorizontale);	
	
			AjouterEvenement(IconeIndiceBarreDefilementH,"mouseup",ArreterDeplacementCurseurHorizontale);				
			AjouterEvenement(IconeIndiceBarreDefilementH,"mouseout",ArreterDeplacementCurseurHorizontale);				

				
			IconeIndiceBarreDefilementH.style.width=BarreDefilementH.style.width;			
			BarreDefilementH.appendChild(IconeIndiceBarreDefilementH);
	/*-------------------------------------------------
					FINALISATION
	-------------------------------------------------*/	
		this.DefinirEpaisseurBarreVerticale(15);
		this.DefinirEpaisseurBarreHorizontale(15);
		this.ActiverDeplacementMouseOver(false);		
		this.ActiverDeplacementMouseClick(true);		
		this.ActiverChangementFondPassageSouris(true);
		this.ActualiserContenuBarre();
		
}